## bsnes 0.088

=== bsnes/Makefile ===
include nall/Makefile

nes  := nes
snes := snes
gb   := gb
gba  := gba

profile := accuracy
target  := ui

# options += console

# compiler
c       := $(compiler) -std=gnu99
cpp     := $(subst cc,++,$(compiler)) -std=gnu++0x
flags   := -I. -O3 -fomit-frame-pointer
link    := -s
objects := libco

# profile-guided optimization mode
# pgo := instrument
# pgo := optimize

ifeq ($(pgo),instrument)
  flags += -fprofile-generate
  link += -lgcov
else ifeq ($(pgo),optimize)
  flags += -fprofile-use
endif

# platform
ifeq ($(platform),x)
  flags += -march=native
  link += -ldl -lX11 -lXext
else ifeq ($(platform),osx)
else ifeq ($(platform),win)
  link += $(if $(findstring console,$(options)),-mconsole,-mwindows)
  link += -mthreads -luuid -lkernel32 -luser32 -lgdi32 -lcomctl32 -lcomdlg32 -lshell32 -lole32
  link += -Wl,-enable-auto-import -Wl,-enable-runtime-pseudo-reloc
else
  unknown_platform: help;
endif

ui := target-$(target)

# implicit rules
compile = \
  $(strip \
    $(if $(filter %.c,$<), \
      $(c) $(flags) $1 -c $< -o $@, \
      $(if $(filter %.cpp,$<), \
        $(cpp) $(flags) $1 -c $< -o $@ \
      ) \
    ) \
  )

%.o: $<; $(call compile)

all: build;

obj/libco.o: libco/libco.c libco/*

include $(ui)/Makefile
flags := $(flags) $(foreach o,$(call strupper,$(options)),-D$o)

# targets
clean:
	-@$(call delete,obj/*.o)
	-@$(call delete,obj/*.a)
	-@$(call delete,obj/*.so)
	-@$(call delete,obj/*.dylib)
	-@$(call delete,obj/*.dll)
	-@$(call delete,*.res)
	-@$(call delete,*.pgd)
	-@$(call delete,*.pgc)
	-@$(call delete,*.ilk)
	-@$(call delete,*.pdb)
	-@$(call delete,*.manifest)

sync:
	if [ -d ./libco ]; then rm -r ./libco; fi
	if [ -d ./nall ]; then rm -r ./nall; fi
	if [ -d ./ruby ]; then rm -r ./ruby; fi
	if [ -d ./phoenix ]; then rm -r ./phoenix; fi
	cp -r ../libco ./libco
	cp -r ../nall ./nall
	cp -r ../ruby ./ruby
	cp -r ../phoenix ./phoenix
	rm -r libco/doc
	rm -r libco/test
	rm -r nall/test
	rm -r ruby/_test
	rm -r phoenix/nall
	rm -r phoenix/test

archive:
	if [ -f bsnes.tar.bz2 ]; then rm bsnes.tar.bz2; fi
	tar -cjf bsnes.tar.bz2 `ls`

help:;

=== purify/Makefile ===
include nall/Makefile

application := purify
flags := -std=gnu++0x -I. -O3 -fomit-frame-pointer
link := -s

ifeq ($(platform),win)
  flags += -DPHOENIX_WINDOWS
  link += -lkernel32 -luser32 -lgdi32 -ladvapi32 -lole32 -lcomctl32 -lcomdlg32
else ifeq ($(phoenix),qt)
  flags += -DPHOENIX_QT `pkg-config --cflags QtCore QtGui`
  link += `pkg-config --libs QtCore QtGui`
else
  flags += -DPHOENIX_GTK `pkg-config --cflags gtk+-2.0`
  link += `pkg-config --libs gtk+-2.0`
endif

all: phoenix.o $(application).o
	$(cpp) -o $(application) phoenix.o $(application).o $(link)

phoenix.o: phoenix/phoenix.cpp
	$(cpp) -c -o phoenix.o phoenix/phoenix.cpp $(flags)

$(application).o: $(application).cpp
	$(cpp) -c -o $(application).o $(application).cpp $(flags)

install:
	sudo cp $(application) /usr/local/bin/$(application)

clean:
	$(delete) *.o

sync:
	if [ -d ./nall ]; then rm -r ./nall; fi
	if [ -d ./phoenix ]; then rm -r ./phoenix; fi
	cp -r ../nall ./nall
	cp -r ../phoenix ./phoenix
	rm -r nall/test
	rm -r phoenix/test

=== snesfilter/Makefile ===
include nall/Makefile

c       := $(compiler) -std=gnu99
cpp     := $(subst cc,++,$(compiler)) -std=gnu++0x
flags   := -fPIC -I. -Iobj -O3 -fomit-frame-pointer
link    := -s
objects :=

ifeq ($(platform),x)
# flags += -fopenmp
endif

objects += out/Pixellate2x.filter
objects += out/Scanline-Dark.filter
objects += out/Scanline-Light.filter
objects += out/Scale2x.filter
objects += out/LQ2x.filter
objects += out/HQ2x.filter
objects += out/Phosphor3x.filter

compile = $(cpp) $(link) $(flags) -o $@ -shared $<

%.filter: $<; $(call compile)

all: build;

out/Pixellate2x.filter: Pixellate2x/Pixellate2x.cpp Pixellate2x/*
out/Scanline-Dark.filter: Scanline/Scanline-Dark.cpp Scanline/*
out/Scanline-Light.filter: Scanline/Scanline-Light.cpp Scanline/*
out/Scale2x.filter: Scale2x/Scale2x.cpp Scale2x/*
out/LQ2x.filter: LQ2x/LQ2x.cpp LQ2x/*
out/HQ2x.filter: HQ2x/HQ2x.cpp HQ2x/*
out/Phosphor3x.filter: Phosphor3x/Phosphor3x.cpp Phosphor3x/*

build: $(objects)

install:
	mkdir -p ~/.config/bsnes/filters
	chmod 777 ~/.config/bsnes/filters
	cp out/*.filter ~/.config/bsnes/filters

clean:
	rm out/*.filter

=== snesshader/Makefile ===
install:
	mkdir -p ~/.config/bsnes/shaders
	chmod 777 ~/.config/bsnes/shaders
	cp *.shader ~/.config/bsnes/shaders

=== bsnes/gb/Makefile ===
options += gameboy

gb_objects := gb-interface gb-system gb-scheduler
gb_objects += gb-memory gb-cartridge
gb_objects += gb-cpu gb-apu gb-lcd
gb_objects += gb-cheat gb-video
objects += $(gb_objects)

obj/gb-interface.o: $(gb)/interface/interface.cpp $(call rwildcard,$(gb)/interface/)
obj/gb-system.o:    $(gb)/system/system.cpp $(call rwildcard,$(gb)/system/)
obj/gb-scheduler.o: $(gb)/scheduler/scheduler.cpp $(call rwildcard,$(gb)/scheduler/)
obj/gb-cartridge.o: $(gb)/cartridge/cartridge.cpp $(call rwildcard,$(gb)/cartridge/)
obj/gb-memory.o:    $(gb)/memory/memory.cpp $(call rwildcard,$(gb)/memory/)
obj/gb-cpu.o:       $(gb)/cpu/cpu.cpp $(call rwildcard,$(gb)/cpu/)
obj/gb-apu.o:       $(gb)/apu/apu.cpp $(call rwildcard,$(gb)/apu/)
obj/gb-lcd.o:       $(gb)/lcd/lcd.cpp $(call rwildcard,$(gb)/lcd/)
obj/gb-cheat.o:     $(gb)/cheat/cheat.cpp $(call rwildcard,$(gb)/cheat/)
obj/gb-video.o:     $(gb)/video/video.cpp $(call rwildcard,$(gb)/video/)

=== bsnes/gba/Makefile ===
gba_objects := gba-memory gba-interface gba-scheduler gba-system
gba_objects += gba-video gba-cartridge
gba_objects += gba-cpu gba-ppu gba-apu
objects += $(gba_objects)

obj/gba-memory.o:    $(gba)/memory/memory.cpp $(call rwildcard,$(gba)/memory)
obj/gba-interface.o: $(gba)/interface/interface.cpp $(call rwildcard,$(gba)/interface)
obj/gba-scheduler.o: $(gba)/scheduler/scheduler.cpp $(call rwildcard,$(gba)/scheduler)
obj/gba-system.o:    $(gba)/system/system.cpp $(call rwildcard,$(gba)/system)
obj/gba-video.o:     $(gba)/video/video.cpp $(call rwildcard,$(gba)/video)
obj/gba-cartridge.o: $(gba)/cartridge/cartridge.cpp $(call rwildcard,$(gba)/cartridge)
obj/gba-cpu.o:       $(gba)/cpu/cpu.cpp $(call rwildcard,$(gba)/cpu)
obj/gba-ppu.o:       $(gba)/ppu/ppu.cpp $(call rwildcard,$(gba)/ppu)
obj/gba-apu.o:       $(gba)/apu/apu.cpp $(call rwildcard,$(gba)/apu)

=== bsnes/nall/Makefile ===
# Makefile
# author: byuu
# license: public domain

[A-Z] = A B C D E F G H I J K L M N O P Q R S T U V W X Y Z
[a-z] = a b c d e f g h i j k l m n o p q r s t u v w x y z
[0-9] = 0 1 2 3 4 5 6 7 8 9
[markup] = ` ~ ! @ \# $$ % ^ & * ( ) - _ = + [ { ] } \ | ; : ' " , < . > / ?
[all] = $([A-Z]) $([a-z]) $([0-9]) $([markup])
[space] :=
[space] +=

#####
# platform detection
#####

ifeq ($(platform),)
  uname := $(shell uname -a)
  ifeq ($(uname),)
    platform := win
    delete = del $(subst /,\,$1)
  else ifneq ($(findstring CYGWIN,$(uname)),)
    platform := win
    delete = del $(subst /,\,$1)
  else ifneq ($(findstring Darwin,$(uname)),)
    platform := osx
    delete = rm -f $1
  else
    platform := x
    delete = rm -f $1
  endif
endif

ifeq ($(compiler),)
  ifeq ($(platform),win)
    compiler := gcc
  else ifeq ($(platform),osx)
    compiler := gcc-mp-4.6
  else
    compiler := gcc-4.6
  endif
endif

c := $(compiler) -std=gnu99
cpp := $(subst cc,++,$(compiler)) -std=gnu++0x

ifeq ($(prefix),)
  prefix := /usr/local
endif

#####
# function rwildcard(directory, pattern)
#####
rwildcard = \
  $(strip \
    $(filter $(if $2,$2,%), \
      $(foreach f, \
        $(wildcard $1*), \
        $(eval t = $(call rwildcard,$f/)) \
        $(if $t,$t,$f) \
      ) \
    ) \
  )

#####
# function strtr(source, from, to)
#####
strtr = \
  $(eval __temp := $1) \
  $(strip \
    $(foreach c, \
      $(join $(addsuffix :,$2),$3), \
      $(eval __temp := \
        $(subst $(word 1,$(subst :, ,$c)),$(word 2,$(subst :, ,$c)),$(__temp)) \
      ) \
    ) \
    $(__temp) \
  )

#####
# function strupper(source)
#####
strupper = $(call strtr,$1,$([a-z]),$([A-Z]))

#####
# function strlower(source)
#####
strlower = $(call strtr,$1,$([A-Z]),$([a-z]))

#####
# function strlen(source)
#####
strlen = \
  $(eval __temp := $(subst $([space]),_,$1)) \
  $(words \
    $(strip \
      $(foreach c, \
        $([all]), \
        $(eval __temp := \
          $(subst $c,$c ,$(__temp)) \
        ) \
      ) \
      $(__temp) \
    ) \
  )

#####
# function streq(source)
#####
streq = $(if $(filter-out xx,x$(subst $1,,$2)$(subst $2,,$1)x),,1)

#####
# function strne(source)
#####
strne = $(if $(filter-out xx,x$(subst $1,,$2)$(subst $2,,$1)x),1,)

=== bsnes/nes/Makefile ===
nes_objects := nes-interface nes-system nes-scheduler nes-input
nes_objects += nes-memory nes-cartridge nes-cpu nes-apu nes-ppu
nes_objects += nes-cheat nes-video
objects += $(nes_objects)

obj/nes-interface.o: $(nes)/interface/interface.cpp $(call rwildcard,$(nes)/interface/)
obj/nes-system.o: $(nes)/system/system.cpp $(call rwildcard,$(nes)/system/)
obj/nes-scheduler.o: $(nes)/scheduler/scheduler.cpp $(call rwildcard,$(nes)/scheduler/)
obj/nes-input.o: $(nes)/input/input.cpp $(call rwildcard,$(nes)/input/)
obj/nes-memory.o: $(nes)/memory/memory.cpp $(call rwildcard,$(nes)/memory/)
obj/nes-cartridge.o: $(nes)/cartridge/cartridge.cpp $(call rwildcard,$(nes)/cartridge/)
obj/nes-cpu.o: $(nes)/cpu/cpu.cpp $(call rwildcard,$(nes)/cpu/)
obj/nes-apu.o: $(nes)/apu/apu.cpp $(call rwildcard,$(nes)/apu/)
obj/nes-ppu.o: $(nes)/ppu/ppu.cpp $(call rwildcard,$(nes)/ppu/)
obj/nes-cheat.o: $(nes)/cheat/cheat.cpp $(call rwildcard,$(nes)/cheat/)
obj/nes-video.o: $(nes)/video/video.cpp $(call rwildcard,$(nes)/video/)

=== bsnes/phoenix/Makefile ===
ifeq ($(platform),x)
  ifeq ($(phoenix),)
    phoenix := gtk
  endif

  ifeq ($(phoenix),gtk)
    phoenixflags := -DPHOENIX_GTK `pkg-config --cflags gtk+-2.0`
    phoenixlink := `pkg-config --libs gtk+-2.0`
  endif

  ifeq ($(phoenix),qt)
    phoenixflags := -DPHOENIX_QT `pkg-config --cflags QtCore QtGui`
    phoenixlink := `pkg-config --libs QtCore QtGui`
  endif
else ifeq ($(platform),win)
  phoenixflags := -DPHOENIX_WINDOWS
  phoenixlink := -lkernel32 -luser32 -lgdi32 -ladvapi32 -lole32 -lcomctl32 -lcomdlg32
else
  phoenixflags := -DPHOENIX_REFERENCE
  phoenixlink :=
endif

=== bsnes/processor/Makefile ===
processor_objects :=
processor_objects += $(if $(findstring arm,$(processors)),processor-arm)
processor_objects += $(if $(findstring hg51b,$(processors)),processor-hg51b)
processor_objects += $(if $(findstring upd96050,$(processors)),processor-upd96050)
objects += $(processor_objects)

processor := processor
obj/processor-arm.o:      $(processor)/arm/arm.cpp $(call rwildcard,$(processor)/arm)
obj/processor-hg51b.o:    $(processor)/hg51b/hg51b.cpp $(call rwildcard,$(processor)/hg51b)
obj/processor-upd96050.o: $(processor)/upd96050/upd96050.cpp $(call rwildcard,$(processor)/upd96050)

=== bsnes/ruby/Makefile ===
rubyflags := $(foreach c,$(subst .,_,$(call strupper,$(ruby))),-D$c)
rubyflags += $(if $(finstring .sdl,$(ruby)),`sdl-config --cflags`)

rubylink :=
rubylink += $(if $(findstring .sdl,$(ruby)),`sdl-config --libs`)
rubylink += $(if $(findstring video.direct3d,$(ruby)),-ld3d9)
rubylink += $(if $(findstring video.directdraw,$(ruby)),-lddraw)
rubylink += $(if $(findstring video.glx,$(ruby)),-lGL)
rubylink += $(if $(findstring video.wgl,$(ruby)),-lopengl32)
rubylink += $(if $(findstring video.xv,$(ruby)),-lXv)
rubylink += $(if $(findstring audio.alsa,$(ruby)),-lasound)
rubylink += $(if $(findstring audio.ao,$(ruby)),-lao)
rubylink += $(if $(findstring audio.directsound,$(ruby)),-ldsound)
rubylink += $(if $(findstring audio.pulseaudio,$(ruby)),-lpulse)
rubylink += $(if $(findstring audio.pulseaudiosimple,$(ruby)),-lpulse-simple)
rubylink += $(if $(findstring audio.xaudio2,$(ruby)),-lole32)
rubylink += $(if $(findstring input.directinput,$(ruby)),-ldinput8 -ldxguid)
rubylink += $(if $(findstring input.rawinput,$(ruby)),-ldinput8 -ldxguid)

ifeq ($(platform),x)
  rubylink += $(if $(findstring audio.openal,$(ruby)),-lopenal)
else ifeq ($(platform),osx)
  rubylink += $(if $(findstring audio.openal,$(ruby)),-framework OpenAL)
else ifeq ($(platform),win)
  rubylink += $(if $(findstring audio.openal,$(ruby)),-lopenal32)
endif

=== bsnes/snes/Makefile ===
snes_objects := snes-interface snes-system snes-controller
snes_objects += snes-cartridge snes-cheat
snes_objects += snes-memory snes-cpucore snes-smpcore
snes_objects += snes-cpu snes-smp snes-dsp snes-ppu
snes_objects += snes-icd2 snes-nss snes-superfx snes-sa1
snes_objects += snes-necdsp snes-hitachidsp snes-armdsp
snes_objects += snes-bsx snes-srtc snes-sdd1 snes-spc7110
snes_objects += snes-obc1 snes-sufamiturbo
snes_objects += snes-msu1 snes-link
objects += $(snes_objects)

ifeq ($(profile),accuracy)
  flags += -DPROFILE_ACCURACY
  snescpu := $(snes)/cpu
  snessmp := $(snes)/smp
  snesdsp := $(snes)/dsp
  snesppu := $(snes)/ppu
else ifeq ($(profile),compatibility)
  flags += -DPROFILE_COMPATIBILITY
  snescpu := $(snes)/cpu
  snessmp := $(snes)/smp
  snesdsp := $(snes)/alt/dsp
  snesppu := $(snes)/alt/ppu-compatibility
else ifeq ($(profile),performance)
  flags += -DPROFILE_PERFORMANCE
  snescpu := $(snes)/alt/cpu
  snessmp := $(snes)/alt/smp
  snesdsp := $(snes)/alt/dsp
  snesppu := $(snes)/alt/ppu-performance
endif

obj/snes-interface.o : $(snes)/interface/interface.cpp $(call rwildcard,$(snes)/interface)
obj/snes-system.o    : $(snes)/system/system.cpp $(call rwildcard,$(snes)/system/)
obj/snes-controller.o: $(snes)/controller/controller.cpp $(call rwildcard,$(snes)/controller/)
obj/snes-memory.o    : $(snes)/memory/memory.cpp $(call rwildcard,$(snes)/memory/)
obj/snes-cpucore.o   : $(snes)/cpu/core/core.cpp $(call rwildcard,$(snes)/cpu/core/)
obj/snes-smpcore.o   : $(snes)/smp/core/core.cpp $(call rwildcard,$(snes)/smp/core/)
obj/snes-cpu.o       : $(snescpu)/cpu.cpp $(call rwildcard,$(snescpu)/)
obj/snes-smp.o       : $(snessmp)/smp.cpp $(call rwildcard,$(snessmp)/)
obj/snes-dsp.o       : $(snesdsp)/dsp.cpp $(call rwildcard,$(snesdsp)/)
obj/snes-ppu.o       : $(snesppu)/ppu.cpp $(call rwildcard,$(snesppu)/)
obj/snes-cartridge.o : $(snes)/cartridge/cartridge.cpp $(snes)/cartridge/*
obj/snes-cheat.o     : $(snes)/cheat/cheat.cpp $(snes)/cheat/*

obj/snes-nss.o        : $(snes)/chip/nss/nss.cpp $(call rwildcard,$(snes)/chip/nss/)
obj/snes-icd2.o       : $(snes)/chip/icd2/icd2.cpp $(call rwildcard,$(snes)/chip/icd2/)
obj/snes-superfx.o    : $(snes)/chip/superfx/superfx.cpp $(call rwildcard,$(snes)/chip/superfx/)
obj/snes-sa1.o        : $(snes)/chip/sa1/sa1.cpp $(call rwildcard,$(snes)/chip/sa1/)
obj/snes-necdsp.o     : $(snes)/chip/necdsp/necdsp.cpp $(call rwildcard,$(snes)/chip/necdsp/)
obj/snes-hitachidsp.o : $(snes)/chip/hitachidsp/hitachidsp.cpp $(call rwildcard,$(snes)/chip/hitachidsp/)
obj/snes-armdsp.o     : $(snes)/chip/armdsp/armdsp.cpp $(call rwildcard,$(snes)/chip/armdsp/)
obj/snes-bsx.o        : $(snes)/chip/bsx/bsx.cpp $(call rwildcard,$(snes)/chip/bsx/)
obj/snes-srtc.o       : $(snes)/chip/srtc/srtc.cpp $(snes)/chip/srtc/*
obj/snes-sdd1.o       : $(snes)/chip/sdd1/sdd1.cpp $(snes)/chip/sdd1/*
obj/snes-spc7110.o    : $(snes)/chip/spc7110/spc7110.cpp $(snes)/chip/spc7110/*
obj/snes-obc1.o       : $(snes)/chip/obc1/obc1.cpp $(snes)/chip/obc1/*
obj/snes-sufamiturbo.o: $(snes)/chip/sufamiturbo/sufamiturbo.cpp $(snes)/chip/sufamiturbo/*
obj/snes-msu1.o       : $(snes)/chip/msu1/msu1.cpp $(snes)/chip/msu1/*
obj/snes-link.o       : $(snes)/chip/link/link.cpp $(snes)/chip/link/*

=== debian/changelog ===
bsnes (0.088-5) unstable; urgency=low

  * Fix issues with bsnes-purify (Closes: #687034):
    - Fix segmentation fault when run with less than two arguments.
    - Purify also files with uppercase suffix.
  * Add missing epoch to versioned Build-Depends on gcc (Closes: #687197).
  * Remove workaround for g++ bug PR c++/53821, which is now fixed in wheezy.
  * Change my email address in debian/control to the debian.org one.
  * Remove DMUA flag.

 -- Tobias Hansen <thansen@debian.org>  Sun, 23 Sep 2012 20:05:41 +0200

bsnes (0.088-4) unstable; urgency=low

  * Add workaround for g++ bug PR c++/53821. (Closes: #684840)

 -- Tobias Hansen <tobias.han@gmx.de>  Tue, 04 Sep 2012 01:54:01 +0200

bsnes (0.088-3) unstable; urgency=low

  * Add bsnes-purify to the bsnes package.
    A command line tool that replaces snespurify and adds:
    - support for ROMs of other systems than SNES
    - creates cartridge folders for ROMs (folders for all data
      belonging to a game - will be mandatory starting from bsnes 0.089)
  * debian/bsnes-purify.6
    - Added. Manual page for bsnes-purify.
  * debian/patches/fix-purify-header-removal-and-input.patch:
    - Added. Header detection was broken and the tool didn't
      accept folder names without trailing slash.
  * debian/changelog:
    - Remove wrong line "Rename snespurify to bsnes-purify."
      from 0.088-1 entry.

 -- Tobias Hansen <tobias.han@gmx.de>  Fri, 11 May 2012 13:15:13 +0200

bsnes (0.088-2) unstable; urgency=low

  * debian/patches/remove-march=native-build-flag.patch:
    - Added. This build flag causes binaries that don't work on all processors
      and is not supported on all architectures.

 -- Tobias Hansen <tobias.han@gmx.de>  Sat, 05 May 2012 13:10:27 +0200

bsnes (0.088-1) unstable; urgency=low

  [Gregor Herrmann]
  * Fix "FTBFS: ./ruby/audio/alsa.cpp:4:28: fatal error:
    alsa/asoundlib.h: No such file or directory":
    build-depend on libasound2-dev (linux) (Closes: #669447)

  [Tobias Hansen]
  * New upstream release.
    - Adds Game Boy Advance support.
    - Removes snespurify sources.
    - Compiles with gcc 4.7. (Closes: #667122)
  * snespurify removed from package bsnes.
  * debian/rules:
    - Don't use the install targets of the makefiles anymore.
    - Check DEB_BUILD_OPTIONS for 'testbuild', build only
      bsnes-compatibility when found to allow for fast test builds.
  * Install new system folders to /usr/share/games/bsnes and 
    /usr/share/games/laevateinn.
    - Copy folders and symlink to files in debian/startscript/bsnes.
    - Rename laevateinn binary to laevateinn-bin, create wrapper script
      laevateinn to copy folders and symlink to files also for laevateinn.
    - Create man page for laevateinn-bin. 
  * debian/bsnes.6:
    - Mention Game Boy Advance support.
    - Mention system folders and bios image required for GBA emulation.
    - Add note that files with wrong extensions or copier headers can't be
      opened.
  * debian/patches/misc-makefile-changes.patch:
    - Removed. Installation is now done in debian/bsnes.install
      and debian/rules.
    - Disabling ALSA is now done in
      debian/patches/disable-alsa-on-non-linux.patch.
  * debian/patches/disable-alsa-on-non-linux.patch:
    - Added. This is what is left of
      debian/patches/misc-makefile-changes.patch.
  * debian/patches/build-snespurify-with-newest-g++.patch:
    - Removed. Obsolete since purify uses a makefile now.
  * debian/patches/use-dpkg-buildflags.patch:
    - Changed. Cope with purify using a makefile.
  * debian/patches/detect-endianness.patch
    debian/patches/detect-non-linux-archs.patch
    debian/patches/snespurify-dont-crash-on-bad-zip-files.patch:
    - Changed. Address upstream changes.
  * debian/patches/declare-functions-in-smp-hpp.patch:
    - Removed. FTBFS was fixed upstream.
  * debian/watch: look for .tar.xz file.

 -- Tobias Hansen <tobias.han@gmx.de>  Sat, 05 May 2012 11:00:20 +0200

bsnes (0.087-1) unstable; urgency=low

  * New upstream release.
  * Include laevateinn, the bsnes debugger:
    - New package laetvateinn.
    - Create debian/laevateinn.6, debian/laevateinn.desktop,
      debian/laevateinn.menu, debian/laevateinn.xpm,
      and debian/laevateinn.png.
  * debian/bsnes.6:
    - Reference laevateinn(6).
  * Add Suggests: laevateinn to bsnes package.
  * debian/patches/declare-functions-in-smp-hpp.patch:
    - Added. Needed to fix FTBFS of bsnes-performance.
  * debian/patches/use-dpkg-buildflags.patch:
    - Added. Makefiles have to be modified to support CFLAGS.
  * debian/patches/reduce-optimization.patch:
    - Removed. With dpkg-buildflags, the optimization flags
      can now be set in debian/rules. 
  * debian/patches/misc-makefile-changes.patch:
    - Changed. Use OpenAL for laevateinns audio on non-Linux archs.
    - Address upstream changes.
  * Adopt new standards:
    - Standards-Version 3.9.3
    - debhelper compat level 9
    - copyright format 1.0
  * Enable (default) hardening buildflags via dpkg-buildflags.
    No optional ones for now, because they could impact performance,
    which is crucial for bsnes.

 -- Tobias Hansen <tobias.han@gmx.de>  Sun, 01 Apr 2012 15:43:00 +0200

=== debian/control ===
Source: bsnes
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Tobias Hansen <thansen@debian.org>
Build-Depends: debhelper (>= 9),
               libgtk2.0-dev,
               libsdl1.2-dev,
               libpulse-dev,
               libopenal-dev,
               libao-dev,
               libxv-dev,
               libasound2-dev [linux-any],
               gcc (>= 4:4.6)
Standards-Version: 3.9.3
Vcs-Git: git://git.debian.org/git/pkg-games/bsnes.git
Vcs-Browser: http://git.debian.org/?p=pkg-games/bsnes.git
Homepage: http://byuu.org/bsnes/

Package: bsnes
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: laevateinn
Description: Accurate SNES/SuperFamicom emulator
 bsnes is an emulator that focuses on accuracy, debugging functionality, and
 clean code. bsnes does not include speed and game-specific hacks for
 compatibility, and as a result the minimum system requirements are very high.
 .
 There are three profiles that differ in the amount of accuracy and required
 system resources. Which profile to use can be set with:
 .
 # update-alternatives --config bsnes-bin
 .
 Although not as polished as the SNES emulation (yet), there is also support
 for NES, Gameboy, Gameboy Color and Gameboy Advance games.
 .
 This package also contains bsnes-purify, a command line tool for preparing
 ROMs for usage with bsnes.

Package: laevateinn
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: bsnes
Description: bsnes SNES/SuperFamicom debugger
 laevateinn is a debugger for SNES/SuperFamicom games based on the bsnes 
 emulator. It is intended for developers creating or modifying SNES games.

=== debian/rules ===
#!/usr/bin/make -f

# With gcc-4.6 4.6.1-15 on Debian unstable i386-kfreebsd something in -O2
# that can't be controlled by a flag causes problems with the bsnes GUI.
# The bsnes GUI doesn't show up at all, snespurify-gtk crashes all the time.
# Using -O1 and enabling all additional flags from -O3 works fine.
CFLAGS += -O1 -fthread-jumps -falign-functions  -falign-jumps -falign-loops \
-falign-labels -fcaller-saves -fcrossjumping -fcse-follow-jumps \
-fcse-skip-blocks -fdelete-null-pointer-checks -fdevirtualize \
-fexpensive-optimizations -fgcse -fgcse-lm -finline-small-functions \
-findirect-inlining -fipa-sra -foptimize-sibling-calls -fpartial-inlining \
-fpeephole2 -fregmove -freorder-blocks -freorder-functions \
-frerun-cse-after-loop -fsched-interblock -fsched-spec -fschedule-insns \
-fschedule-insns2 -fstrict-aliasing -fstrict-overflow -ftree-switch-conversion \
-ftree-pre -ftree-vrp -finline-functions -funswitch-loops -fpredictive-commoning \
-fgcse-after-reload -fipa-cp-clone -fomit-frame-pointer

%:
	dh $@

# We have to clean manually because the Makefile does not support distclean,
# and does not remove compiled bsnes binary
# Don't use make clean for snesfilter because it creates an error if called
# without files to delete.
override_dh_auto_clean:
	$(MAKE) --directory=bsnes clean
	rm -rf bsnes/obj bsnes/out
	rm -rf snesfilter/out
	$(MAKE) --directory=purify clean
	rm -f purify/purify

override_dh_auto_build:
	mkdir -p bsnes/obj bsnes/out snesfilter/out
	dh_auto_build -Dbsnes -- compiler=gcc phoenix=gtk profile=compatibility name=bsnes-compatibility
# Allow for building bsnes only once when testing stuff with the build option testbuild.
ifeq (,$(findstring testbuild,$(DEB_BUILD_OPTIONS)))
	$(MAKE) -Cbsnes clean
	dh_auto_build -Dbsnes -- compiler=gcc phoenix=gtk profile=accuracy name=bsnes-accuracy
	$(MAKE) -Cbsnes clean
	dh_auto_build -Dbsnes -- compiler=gcc phoenix=gtk profile=performance name=bsnes-performance
	$(MAKE) -Cbsnes clean
	dh_auto_build -Dbsnes -- compiler=gcc phoenix=gtk target=debugger name=laevateinn-bin
else
	cp bsnes/out/bsnes-compatibility bsnes/out/bsnes-accuracy
	cp bsnes/out/bsnes-compatibility bsnes/out/bsnes-performance
	cp bsnes/out/bsnes-compatibility bsnes/out/laevateinn-bin
endif
	dh_auto_build -Dsnesfilter -- compiler=gcc
	dh_auto_build -Dpurify -- compiler=gcc
	chmod 644 snesshader/*.OpenGL.shader

override_dh_auto_install:
	install -D -m 644 bsnes/data/bsnes.png debian/bsnes/usr/share/pixmaps/bsnes.png
	install -D -m 644 bsnes/data/bsnes.desktop debian/bsnes/usr/share/applications/bsnes.desktop
	install -D -m 644 bsnes/data/cheats.xml debian/bsnes/usr/share/games/bsnes/cheats.xml
	install -D -m 755 purify/purify debian/bsnes/usr/games/bsnes-purify
	cp -R bsnes/profile/* debian/bsnes/usr/share/games/bsnes
	chmod 644 debian/bsnes/usr/share/games/bsnes/*/*
	mkdir -p debian/laevateinn/usr/share/games/laevateinn
	cp -R bsnes/profile/* debian/laevateinn/usr/share/games/laevateinn
	chmod 644 debian/laevateinn/usr/share/games/laevateinn/*/*

=== debian/watch ===
version=3
opts=\
uversionmangle=s/^/0./,\
downloadurlmangle=s|.*[?]name=(.*?)&.*|http://bsnes.googlecode.com/files/$1|,\
filenamemangle=s|[^/]+[?]name=(.*?)&.*|$1| \
http://code.google.com/p/bsnes/downloads/detail[?]name=bsnes_v([0-9.]+)-source.tar.xz&.*
